

#include "stdafx.h"
#include "WarCmdArg.h"

#ifndef _WAR_INCLUDED_CPP_STRING
#   define _WAR_INCLUDED_CPP_STRING
#   include <string>
#endif // _WAR_INCLUDED_CPP_STRING

using namespace std;

WarCmdArg::WarCmdArg(int argc, char * const *argv, const char * optstring, const option * longopts)
        : m_argc(argc), 
        m_argv(argv), 
        m_optstring(optstring),
        m_longopts(longopts),
        m_ArgIndex(0),
        m_OptIdx(0),
        m_pOptArg(NULL),
        m_Flag(0)
{
}


int WarCmdArg::GetArg()
{
    m_pOptArg = NULL;

    if (!m_OptIdx)
    {
        if (++m_ArgIndex >= m_argc)
            return -1; // End of arguments
    }
    
    if (m_OptIdx 
        || ((m_argv[m_ArgIndex][0] == '-') && (m_argv[m_ArgIndex][1] != '-')))
    {
        // Short form
        char target = m_argv[m_ArgIndex][++m_OptIdx];
        if (target == 0)
        {
            m_OptIdx = 0;
            return GetArg();
        }
        char *pArg = strchr(m_optstring, target);
        if (!pArg)
            return '?';

        if (*++pArg == ':')
        {
            m_pOptArg = &m_argv[m_ArgIndex][m_OptIdx + 1];
            if (!*m_pOptArg)
                m_pOptArg = NULL;
            m_OptIdx = 0;
            if (m_pOptArg == NULL)
            {
                if (*++pArg == ':')
                {
                    // Ok. Optional argument.
                    return target;
                }
                
                if (++m_ArgIndex >= m_argc)
                {
                    --m_ArgIndex;
                    return ':';
                }
                
                m_pOptArg = m_argv[m_ArgIndex];
                return target;
            }
        }

        if (m_pOptArg && !*m_pOptArg )
            m_pOptArg = NULL;
        return target;
    }

    if (((m_argv[m_ArgIndex][0] == '-') && (m_argv[m_ArgIndex][1] == '-')))
    {
        // Long form
        m_Flag = 0;
        const char * target = &m_argv[m_ArgIndex][2];
        const char * eq_p = strchr(target, '=');
        size_t eq_pos = eq_p ? eq_p - target : strlen(target);

        // Search for option
        for(const option *p = m_longopts; p->name ; p++)
        {
            if ((strlen(p->name) >= eq_pos)
                && (p->has_arg 
                ? !strncmp(p->name, target, eq_pos)
                : !strcmp(p->name, target)))
            {
                if (p->has_arg)
                {
                    if (eq_p)
                    {
                        m_pOptArg = ++eq_p;
                        if (!*m_pOptArg)
                            return ':';
                    }
                    else if (p->has_arg == required_argument)
                    {
                        if ((++m_ArgIndex >= m_argc)
                            || (!*(m_pOptArg = m_argv[m_ArgIndex])))
                        {
                            --m_ArgIndex;
                            return ':';
                        }
                    }
                }

                if (p->flag == NULL)
                    return p->val;
                
                {
                    int *pp = (int *)&p->flag;
                    *pp = m_Flag;
                }
                return 0;
            }
        }

        return '?';
    }

    // Not a formal parameter
    return -1;
}
