

#define WARDLLASSIGN(_f,_v) if (!AssignFuncToDLLEntry((LPVOID *)&_f, (ccstr_t)_v, true)) return false
#define WARDLLASSIGNEX(_f,_v) AssignFuncToDLLEntry((LPVOID *)&_f, (ccstr_t)_v, false)

class WarDllWrapper
{
public:
    WarDllWrapper ()
        : m_hDll (NULL), m_bIsLoaded (false)
    {
    }
    
    virtual ~ WarDllWrapper ()
    {
        if (m_hDll)
            ::FreeLibrary (m_hDll);
    }
    virtual bool Create () = 0;
    
protected:
    bool AssignFuncToDLLEntry (LPVOID *Func, LPCSTR Tag, bool bReleaseOnError)
    {
#ifdef _DEBUG
        if (*Func != NULL)
        {
            if (std::cerr.good())
                std::cerr << "AssignFuncToDLLEntry(): Func != NULL in tag " 
                << Tag << std::endl;
        }
#endif
        FARPROC p =::GetProcAddress (m_hDll, Tag);
        if (p)
        {
            *Func = (LPVOID) p;
            return true;
        }
        
        if (bReleaseOnError)
        {
           if (std::cerr.good())
               std::cerr 
               << "AssignFuncToDLLEntry() Failed to resolve dll entry point " 
               << Tag << std::endl;
        }
        return false;
    }
    
    virtual bool _Load () = 0;
    
    virtual bool _Create (const LPCTSTR DllPath)
    {
        if (m_bIsLoaded)
            return true;
        
        if ((m_hDll = (HMODULE) ::LoadLibrary(DllPath)) == NULL)
            return false;
        
        return m_bIsLoaded = _Load ();
    }
    
    HMODULE m_hDll;
    bool m_bIsLoaded;
};

